#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local;
use obbuild;

$default_permissions = 0777;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('opaction1') ne "") { $opaction = $q->param('opaction1'); }
if ($q->param('opaction') ne "") { $opaction = $q->param('opaction'); }

if ($q->param('fct') eq "link_functions") {&start;}
#if ($q->param('fct') eq "edit_items_save") {&edit_items_save;}
if ($q->param('fct') eq "move_items_browse") {&move_items;}
if ($q->param('fct') eq "delete_operation") {&delete_operation;}

##################################################################################


sub start
{

### CHECK IF SOMETHING HAS BEEN SELECTED

$nr_links = $q->param('nr_links');

for ($ms = 0; $ms < $nr_links; $ms++)
	{
	$selv = "C" . $ms;
	
	if ($q->param($selv) ne "")
		{
		$no_error = "true";
		}
	}

if ($no_error ne "true"){acs::problem_popup("You have to select at least one listing.");}


if ($opaction eq "Edit")
	{
	&edit_items;
	}
	elsif ($opaction eq "Move")
	{
	&move_items;
	}
	elsif ($opaction eq "Copy")
	{
	&move_items;
	}
	elsif ($opaction eq "Delete")
	{
	&delete_items;
	}
	
}






sub delete_operation
{

$lnks = $q->param('lnks');

@lnitems = split (/-/, $lnks);

$qstring = "DELETE FROM links WHERE ";

foreach $item (@lnitems)
	{
	$qstring = $qstring . " (lnkid = '$item') or";
	
	$fname1 = "$web_dir/imagefiles/$item" . ".gif";
	$fname2 = "$web_dir/imagefiles/$item" . ".jpg";
	if ((-e $fname1) > 0) { unlink ($fname1); }
	if ((-e $fname2) > 0) { unlink ($fname2); }
	
	}
	$qstring = substr($qstring, 0, length($qstring) - 2);

######

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
######

$sth = $dbh->prepare($qstring);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $qstring";}
$rows = $sth->rows();

$sth->finish;
$dbh->disconnect;

##############

$rid = $q->param('rid');
if (substr($rid, length($rid) -1, 1) eq "-") { chop($rid); }

acs::update_numbers ("-", $rows, $rid);


$cid = $q->param('cid');
open (FCHNG, ">> $data_dir/changed_cats.dat");
print FCHNG "$cid" . ":LEVEL_WHOLE\n";
close (FCHNG);




$hbox = acs::get_heading_box("$web_url/add.gif", "$rows Listing(s)", qq[You may <a href="javascript:onClick=window.close()">close </a>this window. ]);



print <<END_OF_DEL2;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body onUnload="opener.location.reload(true);">
$hbox

</body>
</html>

END_OF_DEL2

}





sub delete_items
{

$nr_links = $q->param('nr_links');

	for ($ms = 0; $ms < $nr_links; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$pval = $q->param($pname);
		$selstring = $selstring . "$pval-";
		}
	
	 }
   chop($selstring);


$rid = $q->param('rid');
$cid = $q->param('cid');





$hbox = acs::get_heading_box("$web_url/add.gif", "Delete Listing(s)", qq[<form method="POST" action="$admin_url/admin5.cgi">
  <input type="hidden" name="fct" value="delete_operation"><input type="hidden" name="lnks"
  value="$selstring"><input type="hidden" name="rid" value="$rid"><input type="hidden"
  name="cid" value="$cid"><p>Are you sure you want to delete the selected listings?<strong> </strong><input
  type="submit" value="   Yes   " name="B1"> <input type="button" value="   No   " name="B2" onClick="window.close(); return false;"></p>
</form>]);


print <<END_OF_DEL;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 
</head>
<body>
$hbox
</body>
</html>

END_OF_DEL

}












sub send_email_move
{

#$sth = $dbh->prepare($sql_move_email);
#$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### GET PREMIUM APPROVAL EMAIL

$papprove_email = acs::get_file_contents("$data_dir/pacceptance.eml");

	@pelines = split (/\n/, $papprove_email);
	
	$pfrom_name = $pelines[0];
	$pfrom_email = $pelines[1];
	$pemail_subject = $pelines[2];


	$plnc = 0;
	foreach $pline (@pelines)
		{
		if ($plnc > 2)
			{
			$pemail_message = $pemail_message . $pline . "\n";
			}
		$plnc++;
		}



### GET APPROVAL EMAIL

$approve_email = acs::get_file_contents("$data_dir/acceptance.eml");

	@elines = split (/\n/, $approve_email);
	
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];


	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}



### GET LINKS THAT IS TO BE APPROVED AND MOVED

$email_sel_sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.* 
						FROM dirs AS A, links as B
						WHERE (A.cid = B.cid) AND ($sql_move_email)";

$sth = $dbh->prepare($email_sel_sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $email_sel_sql";}

while ( @row = $sth->fetchrow() )
	{
		
		### GET CATEGORY
		$cats = "";
		for ($ms1 = 0; $ms1 < 16; $ms1++) 
			{
			if ($row[$ms1] ne "")
				{
				$cats = $cats . $row[$ms1] . "/";
				}
			}

		$lnkid = $row[16];
		$ccid = $row[17];
		$title = $row[18];
		$description = $row[19];
		$keywords = $row[20];
		$url = $row[21];
		$name = $row[24];
		$email = $row[25];
		$date = $row[33];
		$date = acs::decode_date($date);
		$password = $row[38];

		if ($row[29] > 0)
			{
			$prepared_approve_email = $pemail_message;
			}
			else
			{
			$prepared_approve_email = $email_message;
			}
		
		$prepared_approve_email =~ s/%%title%%/$title/gi;
		$prepared_approve_email =~ s/%%description%%/$description/gi;
		$prepared_approve_email =~ s/%%keywords%%/$keywords/gi;
		$prepared_approve_email =~ s/%%url%%/$url/gi;
		$prepared_approve_email =~ s/%%name%%/$name/gi;
		$prepared_approve_email =~ s/%%email%%/$email/gi;
		$prepared_approve_email =~ s/%%date%%/$date/gi;
		$prepared_approve_email =~ s/%%category_submitted%%/$cats/gi;
		$prepared_approve_email =~ s/%%password%%/$password/gi;
		
		$rem_rate = "$script_url/gethtml.cgi?id=$lnkid-$ccid";
		$prepared_approve_email =~ s/%%rating_code_url%%/$rem_rate/gi;

		if ($row[29] > 0)
			{
			acs::send_email ($pfrom_name, $pfrom_email, $email, $pemail_subject, $prepared_approve_email);
			}
			else
			{
			acs::send_email ($from_name, $from_email, $email, $email_subject, $prepared_approve_email);
			}
		}

}







#############

sub move_items
{

for ($ms = 0; $ms < $nr_links; $ms++)
	{
	$selv = "C" . $ms;
	
	if ($q->param($selv) ne "")
		{
		$nrelnk++;
		}
	}

if ($nrelnk > 150)
	{
	acs::problem_popup("The maximum number of links you are allowed to move at a time, is 150.");
	}



if ($q->param('newsub') eq "other")
	{
	$newsub2="other";
	$newsub="newsub=other";
	}
elsif ($q->param('newsub') eq "true")
	{
	$newsub="newsub=true";
	$newsub2="true";
	
	if ($q->param('email') eq "true")
		{
		$newsub = $newsub . "&email=true";
		$newsubemail = "true";
		}
	}




#### GET LINKS TO MOVE

$edit_nr = $q->param('nr_links');

if ($edit_nr ne "")
	{
	$selstring = "mitems=";
	for ($ms = 0; $ms < $nr_links; $ms++)
	 {
	$pname = "C" . $ms;
	if ($q->param($pname) ne "")
		{
		$pval = $q->param($pname);
		$selstring = $selstring . "$pval-";
		$hselstring = $hselstring . "$pval-";
		}
	
	 }
   chop($selstring);
   chop($hselstring);
   
	}
	else
	{
	$selstring = "mitems=" . $q->param('mitems');
	$hselstring = $q->param('mitems');
	}


########

$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID

$last_dname = acs::get_last_dirname($mct);

########

$location = acs::get_location_string ($ct);

########

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$moveval\"> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/admin5.cgi?mlv=$mlv&mct=$dirstring&cid=$cid&rid=$rid&&ct=$ct&fct=move_items_browse&$selstring&opaction=$opaction&$newsub\">$row[28]</a></strong> ($row[20]) $locked_stat<br>";
	}

$sth->finish;
$dbh->disconnect;

#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/admin5.cgi?mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=move_items_browse&$selstring&opaction=$opaction&$newsub\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/admin5.cgi?mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=move_items_browse&$selstring&opaction=$opaction&$newsub\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = <<END_OF_NONE;

<p><strong>This category contains no sub directories/categories. <br>
</strong>Use the back button of your browser to go back or click 'Add Dir' to add a new directory/category.</p>

END_OF_NONE
	}
	else
	{
if ($opaction eq "Copy")
		{
		$movebut = "<input type=\"submit\" value=\"   Copy   \" name=\"movebutton\">";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Move   \" name=\"movebutton\">";
		}
	}

###############

if ($opaction eq "Copy")
	{
	$move_title = "Copy Listings";
	$movew = "Copy";
	$faction = "copy_operation";
	}
	else
	{
	$move_title = "Move Listings";
	$movew = "Move";
	$faction = "move_operation";
	}

###############	

if ($q->param('newsub') eq "true")
	{
	$location = "New Submissions";
	}




if ($q->param('newsub') eq "other") ### IF MOVING LINKS FROM SOMEWHERE ELSE (NOT NEW SUBMISSIONS OR DIR MANAGER)
	{
	$movecgi = "$admin_url/admin56.cgi";
	}
	else ### IF MOVING FROM NEW SUBMISSIONS OR DIR MANAGER
	{

		if ($config_cgi ne "../config.cgi")
		{
		$nlck = $config_cgi;
		$nlck =~ s/config\.cgi/admin\/unlock\.cgi/gi;
		}
		else
		{
		$nlck = "unlock.cgi";
		}

		if ((-e $nlck) > 0)
			{
			$movecgi = "$admin_url/unlock.cgi";
			}
			else
			{
			$movecgi = "$admin_url/admin40.cgi";
			}	
		
	}
	

if ($location eq "Root")
	{
	$tomove_text = qq[Please select a category/directory below.];
	}
	else
	{
	$tomove_text = qq[$movew Listings From: <BR><b>$location</b>];
	}

$hbox = acs::get_heading_box("$web_url/add.gif", "$movew Listing(s)", qq[$tomove_text]);

$helpb = acs::quick_help("Quick Help","Navigate through the categories/directories above by clicking on the category names. Once you have found the appropriate directory/category, select it and click the Move or Copy button.");

		
print <<END_OF_MVL;

<html>
<head>
<title>$move_title</title>

<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }

 // End Hide -->
</script>

</head>
<body>

$hbox

<form method="POST" action="$movecgi">
  <input type="hidden" name="fct" value="$faction"><input type="hidden" name="ct"
  value="$ct"><input type="hidden" name="links_to_move" value="$hselstring"><input
  type="hidden" name="cid" value="$cid"><input type="hidden" name="rid" value="$rid"><input
  type="hidden" name="mct" value="$pmct"><input type="hidden" name="newsub" value="$newsub2"><input
  type="hidden" name="email" value="$newsubemail"><table border="0" cellpadding="6"
  cellspacing="0" width="100%" style="border: 1px solid rgb(221,221,221)">
    <tr>
      <td width="94%" valign="top"><span class="normaltext">$movew Listings To: <br>
      <img src="$web_url/lar.gif" width="6" height="10"> <b>$currentloc</b></span></td>
    </tr>
    <tr>
      <td width="94%" valign="top"><blockquote>
        <p>$movedirs</p>
      </blockquote>
      <blockquote>
        <p>$movebut <input type="submit" value="   Add Dir    " name="createdir"
        onClick="popup('$admin_url/admin2.cgi?fct=addir&amp;ct=$mct&amp;lv=$create_lv&amp;mscr=mscr',800,600);return false;">
        </p>
      </blockquote>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$helpb
</body>
</html>


END_OF_MVL

#&ct=$mct&lv=$create_lv&mscr=mscr

}








##########################


sub edit_items
{


$upload_dir = "$web_dir/imagefiles";
if ((-e $upload_dir) < 1) {
mkdir ($upload_dir, $default_permissions);
chmod($default_permissions,"$upload_dir","$upload_dir"); }
 

$gsettings = new_gsettings acs;

### CHECK THAT MAX 30 AT A TIME


for ($ms = 0; $ms < $nr_links; $ms++)
	{
	$selv = "C" . $ms;
	
	if ($q->param($selv) ne "")
		{
		$nrelnk++;
		}
	}

if ($nrelnk > 50)
	{
	acs::problem_popup("The maximum number of links you can edit at a time is 50.");
	}

###



if ($ct = $q->param('newsub') ne "true")
	{
	$ct = $q->param('ct');
	$location = acs::get_location_string($ct);
	}
	else
	{
	$location = "New Submissions";
	$newsubmis_edit = "<input type=\"hidden\" name=\"newsub\" value=\"true\">";
	}



########################################################

if ($config_cgi ne "../config.cgi")
{
$nlck = $config_cgi;
$nlck =~ s/config\.cgi/admin\/unlock\.cgi/gi;
}
else
{
$nlck = "unlock.cgi";
}

if ((-e $nlck) > 0)
	{
	$editcgi = "$admin_url/unlock.cgi";
	}
	else
	{
	$editcgi = "$admin_url/admin40.cgi";
	}

########################################################



if ($location ne "Root") 
{
$lstring = qq[Editing Listings in: <br><strong>$location</strong>];
}

if ($lstring eq "") { $lstring = "Please find the listing details below."; }

$hbox = acs::get_heading_box("$web_url/add.gif", "Edit Listing(s)", qq[$lstring]);


$editbox = qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css"> 

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=0,toolbar=0,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }

// End Hide -->
</script>

</head>
<body>

$hbox

<form method="POST" action="$editcgi" ENCTYPE="multipart/form-data" name="editform">
<input type="hidden" name="fct" value="edit_items_save">
$newsubmis_edit

];




### BUILD SQL QUERY TO GET SELECTED LINKS TO BE EDITED

for ($ms = 0; $ms < $nr_links; $ms++)
	{
	$selv = "C" . $ms;
	
	if ($q->param($selv) ne "")
		{
		$cidv = $q->param($selv);
		$qstring = $qstring . " (lnkid = '$cidv') or";
		}
	}
$qstring = substr($qstring, 0, length($qstring) - 2);

$serror = "";


### GET KEYS/FIELDS

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


### GET LINKS DATA

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$wsql = "SELECT * FROM links WHERE $qstring ORDER BY title";
$sth = $dbh->prepare($wsql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $wsql"; }
$sth->execute;
$serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}

$edit_nr = 0;
while ( @row = $sth->fetchrow() )
	{

	$title_name = "title" . "$edit_nr";
	$description_name = "description" . "$edit_nr";
	$keywords_name = "keywords" . "$edit_nr";
	$url_name = "url" . "$edit_nr";
	$image_name = "image" . "$edit_nr";
	$imagelinked_name = "imagelinked" . "$edit_nr";
	$name_name = "name" . "$edit_nr";
	$email_name = "email" . "$edit_nr";
	$rating_name = "rating" . "$edit_nr";
	$votes_name = "votes" . "$edit_nr";
	$hits_name = "hits" . "$edit_nr";
	$premium_name = "premium" . "$edit_nr";

	$lnkpassword_name = "lnkpassword" . "$edit_nr";
	
	$urldate_name = "urldate" . "$edit_nr";
	

	$lnkid = "lnkid" . "$edit_nr";

	$premium_expiry = "premium_expiry" . "$edit_nr";

	if ($row[7] eq "Y")
		{
		$imagelinked_name_checked = "checked";
		}
	
	if ($row[10] ne "")
		{
		$rts[$row[10]] = "selected";
		}


	
	$decoded_date = acs::decode_date_numbers($row[17]);
	

##### PREPARE KEYS/FIELDS TO DISPLAY FOR EDITING
$key_disp_data = "";
if ($knr > 0)
{
$kcntr = 27;
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description, $na, $imagef, $fieldtype) = split (/\t/, $k_item);
		
		$origkname = $keyname;
		$keyname = $keyname . $edit_nr;
		
		
		if ($fieldtype eq "Upload") ### IF UPLOAD FIELD
			{

			if ($row[$kcntr] ne "")
				{
				 $fname = "$web_url/imagefiles/$row[0]/" . $origkname . "." . $row[$kcntr];
				 $del_chk_name = $keyname . "del";
				 $del_chk_val = $row[$kcntr];
				 $upl_old_val_name = $keyname . "old";
				 
				 $del_criteria = qq[
				 <table border="0" cellpadding="0" cellspacing="0" width="100%" height="25">
				  <tr class="normaltext"><td height="25"><input type="file" name="$keyname" size="45" style="width:100%"></td></tr>
  				  <tr class="normaltext"><td height="25"><b>Filename:</b> <a href="$fname" target="_blank"><strong>$fname</strong></a></td></tr>
  				  <tr class="normaltext"><td><input type="checkbox" name="$del_chk_name" value="$del_chk_val">Delete this file?</td></tr>
				 </table>
				 ];
				}
				else
				{
				$del_criteria = qq[<input type="file" name="$keyname" size="45" style="width:100%">];
				}
			
				### DISPLAY UPLOAD FIELD
				$key_disp_data = $key_disp_data . qq[
  				 <tr class="normaltext">
		   	  <td width="29%" valign="top" bgcolor="#FFFFFF"><span class="normaltext"><strong> <font color="#804040">$description:</font></strong></span></td>
		   	  <td width="72%" bgcolor="#FFFFFF">$del_criteria
		   	  <input type="hidden" name="$upl_old_val_name" value="$row[$kcntr]"></td></tr>
				];
			
			}
			elsif ($imagef eq "Yes")
			{
			$key_disp_data = $key_disp_data . qq[
			  <tr><td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><font color="#008040"><b>$description:</b></font></td>
    		  <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$keyname" size="60" value="$row[$kcntr]" style="width:100%"></td></tr>
			];		
			}
			elsif ($size < 256) ### IF NON SCROLLING TEXT BOX
			{
			$encoded_html_extra = acs::htmlencode($row[$kcntr]);
				
			$key_disp_data = $key_disp_data . qq[
			  <tr><td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><font color="#8080C0"><b>$description:</b></font></td>
    		  <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$keyname" size="60" value="$encoded_html_extra" style="width:100%"></td></tr>
			];
			}
			else ### IF SCROLLING TEXT BOX
			{
			$key_disp_data = $key_disp_data . qq[
			   <tr><td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><font color="#8080C0"><b>$description:</b></font></td>
		      <td width="72%" bgcolor="#FFFFFF"><textarea rows="7" name="$keyname" cols="47" style="width:100%">$row[$kcntr]</textarea><br></td></tr>
		  		];
			}
			
		$kcntr++;
		}	
}	


#### PREPARE EDITING DISPLAYS

if ($row[21] > 0)
	{
	$expdate = acs::decode_date_numbers($row[21]);
	}
	else
	{
	$expdate = "";
	}

#$time = timelocal($sec,$min,$hours,$mday,$mon,$year);
    

#### IF THE LISTING HAS AN IMAGE

$image_upload_box_name = "image_up" . $edit_nr;
$checkboxname = "del_image" . $edit_nr;

if ($row[6] ne "")
	{

if ((lc($row[6]) eq "tif") or (lc($row[6]) eq "png") or (lc($row[6]) eq "jpg") or (lc($row[6]) eq "jpeg") or (lc($row[6]) eq "gif") or (lc($row[6]) eq "bmp"))
		{

			if (($gsettings->{image_width} > 0) and ($gsettings->{image_height} > 0))
				{
				$width = $gsettings->{image_width};
				$height = $gsettings->{image_height};
				$imgwh = qq[width="$width" height="$height"];
				}
	
				$image_crit = qq[<tr>
 						<td width="29%" valign="top" class="normaltext"  bgcolor="#FFFFFF"><strong>Image:</strong></td>
 						<td width="72%" class="normaltext"  bgcolor="#FFFFFF"><img src="$web_url/imagefiles/$row[0].$row[6]" $imgwh>
 						<br><input type="file" name="$image_upload_box_name" size="51" style="width:90%"><br><input type="checkbox" name="$checkboxname" value="Y">Delete this image?</td>
						</tr>];
		}
		else
		{
				$image_crit = qq[<tr>
 						<td width="29%" valign="top" class="normaltext"  bgcolor="#FFFFFF"><strong>File:</strong></td>
 						<td width="72%" class="normaltext"  bgcolor="#FFFFFF"><a href="$web_url/imagefiles/$row[0].$row[6]" target="_blank"><b>$row[0].$row[6]</b></a><BR>
 						<br><input type="file" name="$image_upload_box_name" size="51" style="width:90%"><br><input type="checkbox" name="$checkboxname" value="Y">Delete this image?</td>
						</tr>];		
		}


	}
else
	{
$image_crit = qq[
<tr>
 <td width="29%" valign="top" class="normaltext"  bgcolor="#FFFFFF"><strong>Image/File:</strong></td>
 	<td width="72%" class="normaltext"  bgcolor="#FFFFFF">
 	<input type="file" name="$image_upload_box_name" size="51" style="width:90%">
 	</td>
</tr>
];
	}

$imageh = "image" . $edit_nr;

$row[2] = acs::htmlencode($row[2]);
$row[4] = acs::htmlencode($row[4]);
$row[5] = acs::htmlencode($row[5]);
$row[8] = acs::htmlencode($row[8]);
$row[9] = acs::htmlencode($row[9]);
$row[22] = acs::htmlencode($row[22]);

if ($gsettings->{addurl_reg_system} ne "Yes")
	{
	$modpass = qq[
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Modify Password:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$lnkpassword_name" size="30" value="$row[22]">    </td>
  </tr>
  ];
	}


$editbox = $editbox . <<END_OF_EB;

<input type="hidden" name="$lnkid" value="$row[0]">
<input type="hidden" name="$imageh" value="$row[6]">

<table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DBDBDB">
  <tr>
    <td colspan="2" valign="top" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Listing Details:</strong></td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Title:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$title_name" size="60"
     value="$row[2]" style="width:100%">
        <br>
      Max 255 Chars </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Description:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><textarea rows="6" name="$description_name" cols="59" style="width:100%">$row[3]</textarea>
        <br>
      Max 255 Characters </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Keywords:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$keywords_name" size="60" style="width:100%" value="$row[4]">
        <br>
      Max 255 Characters </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>URL:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$url_name" size="60" style="width:100%" value="$row[5]">
        <br>
      Max 255 Characters </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Name:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$name_name" size="43" style="width:100%" value="$row[8]">
        <br>
      Max 100 Characters - The name of the submitter or company name </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Email Address:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$email_name" size="60" style="width:100%" value="$row[9]">
        <br>
      Max 255 Characters - You can use this email address for mailing list purposes </td>
  </tr>
$modpass
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Date:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$urldate_name" size="13" value="$decoded_date">
      (YYYY/MM/DD) </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Rating:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><select name="$rating_name" size="1">
        <option value="0"> Unrated </option>
        <option $rts[10] value="10"> 10 </option>
        <option $rts[9] $rts value="9"> 9 </option>
        <option $rts[8] value="8"> 8 </option>
        <option $rts[7] value="7"> 7 </option>
        <option $rts[6] value="6"> 6 </option>
        <option $rts[5] value="5"> 5 </option>
        <option $rts[4] value="4"> 4 </option>
        <option $rts[3] value="3"> 3 </option>
        <option $rts[2] value="2"> 2 </option>
        <option $rts[1] value="1"> 1 </option>
      </select>    </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Number of Votes:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$votes_name" size="8" value="$row[11]">
        <br>
      Number of votes this listing has received </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Number of Hits:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$hits_name" size="8" value="$row[12]">
        <br>
      Number of hits [mouse-clicks] this listing has received </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Premium Position:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$premium_name" size="8" value="$row[13]">
        <br>
      If this field has a value, then this listing will be considered a premium listing. For
      example, if this value is set to 100 and others are set to 99, 98, etc.. then this listing
      will be listed first. Listings with higher numbers are listed above listings with lower
      numbers. </td>
  </tr>
  <tr>
    <td width="29%" valign="top" bgcolor="#FFFFFF" class="normaltext"><b>Premium Expiry Date:</b> </td>
    <td width="72%" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="$premium_expiry" size="13"
     value="$expdate">
      (YYYY/MM/DD) <br>
      This link will not be a premium listing anymore if the above date has been reached.
      Premium links with no expiry dates (if this field is left blank) will not expire. </td>
  </tr>
  
$image_crit
$key_disp_data
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


END_OF_EB
	
	$edit_nr++;
	}

$sth->finish;
$dbh->disconnect;

########################

$editbox = $editbox . "<input type=\"hidden\" name=\"edit_nr\" value=\"$edit_nr\">";
$editbox = $editbox . qq[<BR><table border="0" cellpadding="6" cellspacing="1" width="100%" bgcolor="#DBDBDB">
  <tr>
    <td width="29%" bgcolor="#FFFFFF"></td>
    <td width="72%" bgcolor="#FFFFFF"><input type="submit"
    value="          Save Changes          " name="B1"></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form><BR>];

print $editbox;

}







####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

